import 'package:flutter/material.dart';
import 'package:gist_flutter/gist.dart';

void main() {
  runApp(MyApp());
}

class MyApp extends StatefulWidget {
  @override
  _MyAppState createState() => _MyAppState();
}

class _MyAppState extends State<MyApp> implements GistDelegate {
  @override
  void initState() {
    super.initState();
    Gist.setup("c6ff92b9-5607-4655-9265-f2588f7e3b58");
    Gist.setUserToken("ABC123");
    Gist.subscribeToTopic("Announcements");
    Gist.eventListeners.add(this);
  }

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      home: Scaffold(
        appBar: AppBar(
          title: const Text('Gist example app'),
        ),
        body: Center(
          child: Text('Flutter Gist'),
        ),
      ),
    );
  }

  @override
  onAction(message, action) {
    debugPrint("Action: Message instance: ${message.instanceId}, with id: ${message.messageId} and queue id: ${message.queueId}");
    debugPrint("Action: Message action: ${action.action} on route ${action.currentRoute}");
  }

  @override
  onError(message) {
    debugPrint("Error: Message instance: ${message.instanceId}, with id: ${message.messageId} and queue id: ${message.queueId}");
  }

  @override
  onMessageDismissed(message) {
    debugPrint("Dismissed: Message instance: ${message.instanceId}, with id: ${message.messageId} and queue id: ${message.queueId}");
  }

  @override
  onMessageShown(message) {
    debugPrint("Shown: Message instance: ${message.instanceId}, with id: ${message.messageId} and queue id: ${message.queueId}");
  }
}
